(   Title:  Enhanced error display for btester
     File:  btester-errors.fs
 Log file:  gmpfr.log
   Author:  David N. Williams
  License:  Public Domain
  Version:  1.5.0
  Revised:  February 20, 2011
)

VARIABLE BT-#ERRORS    0 BT-#ERRORS !
: BT-ERROR1  ( c-addr u -- )
\ Display an error message followed by the line that had the
\ error.
  red-text 1 BT-#ERRORS +! BT-ERROR-DEFAULT normal-text ;
\ ' BT-ERROR1 BT-ERROR-XT !

\ display results and goals
: bt-a.  ( 'array c-addr u -- )
  blue-text type
  ( 'array) dup >r @ dup
  IF   1- r> cell+ swap cells over +  \ display deepest first
       DO i b@ b. space -1 cells +LOOP
  ELSE r> 2drop ." none" THEN cr normal-text ;

: BT-ERROR2  ( c-addr u -- )
  BT-ERROR1
  bt-results s"  bresults: " bt-a.
  bt-goals   s"    bgoals: " bt-a. ;
\ ' BT-ERROR2 BT-ERROR-XT !

\ fancy results and goals display
: bt-fancy-a.  ( 'array c-addr u -- )
  blue-text type
  ( 'array) dup @ swap cell+ swap ?dup
  IF   ( n) 1- 0 swap  \ display deepest first
       DO ( 'elem) i cells over + b@
          i bt-error-index @ =
          IF red-text b. blue-text ELSE b. THEN space
       -1 +LOOP
  ELSE ." none" THEN drop cr normal-text ;

: BT-ERROR3  ( c-addr u -- )
  BT-ERROR1
  bt-results s"  bresults: " bt-fancy-a.
  bt-goals   s"    bgoals: " bt-fancy-a. ;
' BT-ERROR3 BT-ERROR-XT !

: ?.bt-errors  ( -- )
  VERBOSE @ IF
  blue-text ." BT-ERRORS: " normal-text BT-#ERRORS @ . THEN ;
