(   Title:  Enhanced error display for ftester
     File:  ftester-errors.fs
   Author:  David N. Williams
  License:  Public Domain
  Version:  1.3.1
  Revised:  January 31, 2011

The date above may reflect cosmetic changes not logged here.

Version 1.3.1
31Jan11 * Adjusted error index to zero base.
        * Removed "Unexpected" from ?.FT-ERRORS.
        * Renamed FT-A. and FT-ERROR2 as FT-FANCY-A. and FT-ERROR3.
        * Added less fancy display in FT-A. and FT-ERROR2.

Version 1.3.0
17Jan11 * Extracted from ttester-xf-test.fs 1.2.1.
)

VARIABLE FT-#ERRORS    0 FT-#ERRORS !
: FT-ERROR1  ( c-addr u -- )
\ Display an error message followed by the line that had the
\ error.
  red-text 1 FT-#ERRORS +! FT-ERROR-DEFAULT normal-text ;
\ ' FT-ERROR1 FT-ERROR-XT !

\ display results and goals
: ft-a.  ( 'array c-addr u -- )
  blue-text type
  ( 'array) dup >r @ dup
  IF   1- r> cell+ faligned swap floats over +  \ display deepest first
       DO i f@ f. -1 floats +LOOP
  ELSE r> 2drop ." none" THEN cr normal-text ;

: FT-ERROR2  ( c-addr u -- )
  FT-ERROR1
  FT-RESULTS s"   fresults: " ft-a.
  FT-GOALS   s"     fgoals: " ft-a. ;
\ ' XT-ERROR2 XT-ERROR-XT !


\ fancy results and goals display
: ft-fancy-a.  ( 'array c-addr u -- )
  blue-text type
  ( 'array) dup @ swap cell+ faligned swap ?dup
  IF   ( n) 1- 0 swap  \ display deepest first 
       DO ( 'floats) i floats over + f@
          i FT-ERROR-INDEX @ =
          IF red-text f. blue-text ELSE f. THEN
       -1 +LOOP
  ELSE ." none" THEN drop cr normal-text ;

: FT-ERROR3  ( c-addr u -- )
  FT-ERROR1
  FT-RESULTS s"   fresults: " ft-fancy-a.
  FT-GOALS   s"     fgoals: " ft-fancy-a. ;
' FT-ERROR3 FT-ERROR-XT !

: ?.ft-errors  ( -- )
  VERBOSE @ IF
  blue-text ." FT-ERRORS: " normal-text FT-#ERRORS @ . THEN ;
