(     Title:  Gforth bindings for the GNU Multiple
              Precision Library, GNU MP 5.0.1
       File:  libgmp-gforth.fs
  Test file:  gmpfr-test.fs
     Author:  David N. Williams
    License:  LGPL
    Version:  0.8.4
    Started:  February 24, 2011 
    Revised:  April 23, 2011

Any part of this file not derived from the GMP library is
)  
\ Copyright  (C) 2011 by David N. Williams
(  
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or at your option any later version.

This library is distributed in the hope that it will be useful 
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Library General Public License for moref details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA 02111-1307 USA.
)

cell 4 = [IF]
c-library libgmp_gforth
[ELSE]
c-library libgmp64_gforth
[THEN]

\ clear-libs

s" gmp" add-lib
s" $HOME/lib" add-libpath

\c #include <stdio.h>

cell 4 = [IF]
\c #include <gmp.h>
[ELSE]
\c #include <gmp64.h>
[THEN]

\c #if !defined (__STDC__) 
\c #error __STDC__ not defined
\c #endif

\ libgmp 5.0.1 functions

\ 5.1 Initialization

c-function mpz_init mpz_init a -- void
c-function mpz_clear mpz_clear a -- void

\ 5.2 Assignment

c-function mpz_set mpz_set a a -- void
c-function mpz_set_ui mpz_set_ui a n -- void
c-function mpz_set_si mpz_set_si a n -- void
c-function mpz_set_d mpz_set_d a r -- void
c-function mpz_set_q mpz_set_q a a -- void
c-function mpz_set_f mpz_set_f a a -- void
c-function mpz_set_str mpz_set_str a a n -- n
c-function mpz_swap mpz_swap a a -- void

\ 5.3 Combined initialization and assignment

c-function mpz_init_set mpz_init_set a a -- void
c-function mpz_init_set_ui mpz_init_set_ui a n -- void
c-function mpz_init_set_si mpz_init_set_si a n -- void
c-function mpz_init_set_d mpz_init_set_d a r -- void
c-function mpz_init_set_str mpz_init_set_str a a n -- n

\ 5.4 Conversion

c-function mpz_get_ui mpz_get_ui a -- n
c-function mpz_get_si mpz_get_si a -- n 
c-function mpz_get_d mpz_get_d a -- r
c-function mpz_get_d_2exp mpz_get_d_2exp a a -- r
c-function mpz_get_str mpz_get_str a n a -- a

\ 5.5 Arithmetic

c-function mpz_add mpz_add a a a -- void
c-function mpz_add_ui mpz_add_ui a a n -- void
c-function mpz_sub mpz_sub a a a -- void
c-function mpz_sub_ui mpz_sub_ui a a n -- void
c-function mpz_ui_sub mpz_ui_sub a n a -- void
c-function mpz_mul mpz_mul a a a -- void
c-function mpz_mul_si mpz_mul_si a a n -- void
c-function mpz_mul_ui mpz_mul_ui a a n -- void
c-function mpz_addmul mpz_addmul a a a -- void
c-function mpz_addmul_ui mpz_addmul_ui a a n -- void
c-function mpz_submul mpz_submul a a a -- void
c-function mpz_submul_ui mpz_submul_ui a a n -- void
c-function mpz_mul_2exp mpz_mul_2exp a a n -- void
c-function mpz_neg mpz_neg a a -- void
c-function mpz_abs mpz_abs a a -- void

\ 5.6 Division

c-function mpz_cdiv_q mpz_cdiv_q a a a -- void
c-function mpz_cdiv_r mpz_cdiv_r a a a -- void
c-function mpz_cdiv_qr mpz_cdiv_qr a a a a -- void
c-function mpz_cdiv_q_ui mpz_cdiv_q_ui a a n -- n
c-function mpz_cdiv_r_ui mpz_cdiv_r_ui a a n -- n
c-function mpz_cdiv_qr_ui mpz_cdiv_qr_ui a a a n -- n
c-function mpz_cdiv_ui mpz_cdiv_ui a n -- n
c-function mpz_cdiv_q_2exp mpz_cdiv_q_2exp a a n -- void
c-function mpz_cdiv_r_2exp mpz_cdiv_r_2exp a a n -- void
c-function mpz_fdiv_q mpz_fdiv_q a a a -- void
c-function mpz_fdiv_r mpz_fdiv_r a a a -- void
c-function mpz_fdiv_qr mpz_fdiv_qr a a a a -- void
c-function mpz_fdiv_q_ui mpz_fdiv_q_ui a a n -- n
c-function mpz_fdiv_r_ui mpz_fdiv_r_ui a a n -- n
c-function mpz_fdiv_qr_ui mpz_fdiv_qr_ui a a a n -- n
c-function mpz_fdiv_ui mpz_fdiv_ui a n -- n
c-function mpz_fdiv_q_2exp mpz_fdiv_q_2exp a a n -- void
c-function mpz_fdiv_r_2exp mpz_fdiv_r_2exp a a n -- void
c-function mpz_tdiv_q mpz_tdiv_q a a a -- void
c-function mpz_tdiv_r mpz_tdiv_r a a a -- void
c-function mpz_tdiv_qr mpz_tdiv_qr a a a a -- void
c-function mpz_tdiv_q_ui mpz_tdiv_q_ui a a n -- n
c-function mpz_tdiv_r_ui mpz_tdiv_r_ui a a n -- n
c-function mpz_tdiv_qr_ui mpz_tdiv_qr_ui a a a n -- n
c-function mpz_tdiv_ui mpz_tdiv_ui a n -- n
c-function mpz_tdiv_q_2exp mpz_tdiv_q_2exp a a n -- void
c-function mpz_tdiv_r_2exp mpz_tdiv_r_2exp a a n -- void
c-function mpz_mod mpz_mod a a a -- void
c-function mpz_mod_ui mpz_mod_ui a a n -- n
c-function mpz_divexact mpz_divexact a a a -- void
c-function mpz_divexact_ui mpz_divexact_ui a a n -- void
c-function mpz_divisible_p mpz_divisible_p a a -- n
c-function mpz_divisible_ui_p mpz_divisible_ui_p a n -- n
c-function mpz_divisible_2exp_p mpz_divisible_2exp_p a n -- n
c-function mpz_congruent_p mpz_congruent_p a a a -- n
c-function mpz_congruent_ui_p mpz_congruent_ui_p a n n -- n
c-function mpz_congruent_2exp_p mpz_congruent_2exp_p a a n -- n

\ 5.7 Exponentiation

c-function mpz_powm mpz_powm a a a a -- void
c-function mpz_powm_ui mpz_powm_ui a a n a -- void
c-function mpz_powm_sec mpz_powm_sec a a a a -- void
c-function mpz_pow_ui mpz_pow_ui a a n -- void
c-function mpz_ui_pow_ui mpz_ui_pow_ui a n n -- void

\ 5.8 Root extraction

c-function mpz_root mpz_root a a n -- n
c-function mpz_rootrem  mpz_rootrem a a a n -- void
c-function mpz_sqrt mpz_sqrt a a -- void
c-function mpz_sqrtrem mpz_sqrtrem a a a -- void
c-function mpz_perfect_power_p mpz_perfect_power_p a -- n
c-function mpz_perfect_square_p mpz_perfect_square_p a -- n

\ 5.9 Number theoretics

c-function mpz_probab_prime_p mpz_probab_prime_p a n -- n
c-function mpz_nextprime mpz_nextprime a a -- void
c-function mpz_gcd mpz_gcd a a a -- void
c-function mpz_gcd_ui mpz_gcd_ui a a n -- n
c-function mpz_gcdext mpz_gcdext a a a a a -- void
c-function mpz_lcm mpz_lcm a a a -- void
c-function mpz_lcm_ui mpz_lcm_ui a a n -- void
c-function mpz_invert mpz_invert a a a -- n
c-function mpz_jacobi mpz_jacobi a a -- n
c-function mpz_legendre mpz_legendre a a -- n
c-function mpz_kronecker mpz_kronecker a a -- n
c-function mpz_kronecker_si mpz_kronecker_si a n -- n
c-function mpz_kronecker_ui mpz_kronecker_ui a n -- n
c-function mpz_si_kronecker mpz_si_kronecker n a -- n
c-function mpz_ui_kronecker mpz_ui_kronecker n a -- n
c-function mpz_remove mpz_remove a a a -- n
c-function mpz_fac_ui mpz_fac_ui a n -- void
c-function mpz_bin_ui mpz_bin_ui a a n -- void
c-function mpz_bin_uiui mpz_bin_uiui a n n -- void
c-function mpz_fib_ui mpz_fib_ui a n -- void
c-function mpz_fib2_ui mpz_fib2_ui a a n -- void
c-function mpz_lucnum_ui mpz_lucnum_ui a n -- void
c-function mpz_lucnum2_ui mpz_lucnum2_ui a a n -- void

\ 5.10 Comparison

c-function mpz_cmp mpz_cmp a a -- n
c-function mpz_cmp_d mpz_cmp_d a r -- n
\ c-function mpz_cmp_si mpz_cmp_si a n -- n
\ c-function mpz_cmp_ui mpz_cmp_ui a n -- n
c-function mpz_cmpabs mpz_cmpabs a a -- n
c-function mpz_cmpabs_d mpz_cmpabs_d a r -- n
c-function mpz_cmpabs_ui mpz_cmpabs_ui a n -- n
\ c-function mpz_sgn mpz_sgn a -- n

\ 5.11 Logic and bit manipulation

c-function mpz_and mpz_and a a a -- void
c-function mpz_ior mpz_ior a a a -- void
c-function mpz_xor mpz_xor a a a -- void
c-function mpz_com mpz_com a a -- void
c-function mpz_popcount mpz_popcount a -- n
c-function mpz_hamdist mpz_hamdist a a -- n
c-function mpz_scan0 mpz_scan0 a n -- n
c-function mpz_scan1 mpz_scan1 a n -- n
c-function mpz_setbit mpz_setbit a n -- void
c-function mpz_clrbit mpz_clrbit a n -- void
c-function mpz_combit mpz_combit a n -- void
c-function mpz_tstbit mpz_tstbit a n -- n

\ 5.12 Input and output

c-function mpz_out_str mpz_out_str a n a -- n
c-function mpz_inp_str mpz_inp_str a a n -- n
c-function mpz_out_raw mpz_out_raw a a -- n
c-function mpz_inp_raw mpz_inp_raw a a -- n

\ 5.13 Random numbers

c-function mpz_urandomb mpz_urandomb a a n -- void
c-function mpz_urandomm mpz_urandomm a a a -- void
c-function mpz_rrandomb mpz_rrandomb a a n -- void
c-function mpz_random mpz_random a n -- void
c-function mpz_random2 mpz_random2 a n -- void

\ 5.14 Integer export and import

c-function mpz_import mpz_import a n n n n n a -- void
c-function mpz_export mpz_export a a n n n n a -- a

\ 5.15 Miscellaneous

c-function mpz_fits_ulong_p mpz_fits_ulong_p a -- n
c-function mpz_fits_slong_p mpz_fits_slong_p a -- n
c-function mpz_fits_uint_p mpz_fits_uint_p a -- n
c-function mpz_fits_sint_p mpz_fits_sint_p a -- n
c-function mpz_fits_ushort_p mpz_fits_ushort_p a -- n
c-function mpz_fits_sshort_p mpz_fits_sshort_p a -- n
\ c-function mpz_odd_p mpz_odd_p a -- n
\ c-function mpz_even_p mpz_even_p a -- n
c-function mpz_sizeinbase mpz_sizeinbase a n -- n

\ 5.16 Special

c-function mpz_array_init mpz_array_init a n n -- void
c-function _mpz_realloc _mpz_realloc a n -- a
c-function mpz_getlimbn mpz_getlimbn a n -- n
c-function mpz_size mpz_size a -- n

\ 6 Rationals

c-function mpq_canonicalize mpq_canonicalize a -- void

\ 6.1 Initialization and assignment

c-function mpq_init mpq_init a -- void
c-function mpq_clear mpq_clear a -- void
c-function mpq_set mpq_set a a -- void
c-function mpq_set_z mpq_set_z a a -- void
c-function mpq_set_ui mpq_set_ui a n n -- void
c-function mpq_set_si mpq_set_si a n n -- void
c-function mpq_set_str mpq_set_str a a n -- n
c-function mpq_swap mpq_swap a a -- void

\ 6.2 Conversion

c-function mpq_get_d mpq_get_d a -- r
c-function mpq_set_d mpq_set_d a r -- void
c-function mpq_set_f mpq_set_f a a -- void
c-function mpq_get_str mpq_get_str a n a -- a

\ 6.3 Arithmetic

c-function mpq_add mpq_add a a a -- void
c-function mpq_sub mpq_sub a a a -- void
c-function mpq_mul mpq_mul a a a -- void
c-function mpq_mul_2exp mpq_mul_2exp a a n -- void
c-function mpq_div mpq_div a a a -- void
c-function mpq_div_2exp mpq_div_2exp a a n -- void
c-function mpq_neg mpq_neg a a -- void
c-function mpq_abs mpq_abs a a -- void
c-function mpq_inv mpq_inv a a -- void

\ 6.4 Comparison

c-function mpq_cmp mpq_cmp a a -- n
\ c-function mpq_cmp_ui mpq_cmp_ui a n n -- n
\ c-function mpq_cmp_si mpq_cmp_si a n n -- n
\ c-function mpq_sgn mpq_sgn a -- n
c-function mpq_equal mpq_equal a a -- n

\ 6.5 Integer functions

\ c-function mpq_numref mpq_numref a -- a
\ c-function mpq_denref mpq_denref a -- a
c-function mpq_get_num mpq_get_num a a -- void
c-function mpq_get_den mpq_get_den a a -- void
c-function mpq_set_num mpq_set_num a a -- void
c-function mpq_set_den mpq_set_den a a -- void

\ 6.6 Input and output

c-function mpq_out_str mpq_out_str a n a -- n
c-function mpq_inp_str mpq_inp_str a a n -- n

\ 7 Floating point

\ 7.1 Initialization

c-function mpf_set_default_prec mpf_set_default_prec n -- void
c-function mpf_get_default_prec mpf_get_default_prec -- n
c-function mpf_init  mpf_init a -- void
c-function mpf_init2 mpf_init2 a n -- void
c-function mpf_clear mpf_clear a -- void
c-function mpf_get_prec mpf_get_prec a -- n
c-function mpf_set_prec mpf_set_prec a n -- void
c-function mpf_set_prec_raw mpf_set_prec_raw a n -- void

\ 7.2 Assignment

c-function mpf_set mpf_set a a -- void
c-function mpf_set_ui mpf_set_ui a n -- void
c-function mpf_set_si mpf_set_si a n -- void
c-function mpf_set_d mpf_set_d a r -- void
c-function mpf_set_z mpf_set_z a a -- void
c-function mpf_set_q mpf_set_q a a -- void
c-function mpf_set_str mpf_set_str a a n -- n
c-function mpf_swap mpf_swap a a -- void

\ 7.3 Combined initialization and assignment

c-function mpf_init_set mpf_init_set a a -- void
c-function mpf_init_set_ui mpf_init_set_ui a n -- void
c-function mpf_init_set_si mpf_init_set_si a n -- void
c-function mpf_init_set_d mpf_init_set_d a r -- void
c-function mpf_init_set_str mpf_init_set_str a a n -- n

\ 7.4 Conversion

c-function mpf_get_d mpf_get_d a -- r
c-function mpf_get_d_2exp mpf_get_d_2exp a a -- r
c-function mpf_get_si mpf_get_si a -- n
c-function mpf_get_ui mpf_get_ui a -- n
c-function mpf_get_str mpf_get_str a a n n a -- a

\ 7.5 Arithmetic

c-function mpf_add mpf_add a a a -- void
c-function mpf_add_ui mpf_add_ui a a n -- void
c-function mpf_sub mpf_sub a a a -- void
c-function mpf_ui_sub mpf_ui_sub a n a -- void
c-function mpf_sub_ui mpf_sub_ui a a n -- void
c-function mpf_mul mpf_mul a a a -- void
c-function mpf_mul_ui mpf_mul_ui a a n -- void
c-function mpf_div mpf_div a a a -- void
c-function mpf_ui_div mpf_ui_div a n a -- void
c-function mpf_div_ui mpf_div_ui a a n -- void
c-function mpf_sqrt mpf_sqrt a a -- void
c-function mpf_sqrt_ui mpf_sqrt_ui a n -- void
c-function mpf_pow_ui mpf_pow_ui a a n -- void
c-function mpf_neg mpf_neg a a -- void
c-function mpf_abs mpf_abs a a -- void
c-function mpf_mul_2exp mpf_mul_2exp a a n -- void
c-function mpf_div_2exp mpf_div_2exp a a n -- void

\ 7.6 Comparison

c-function mpf_cmp mpf_cmp a a -- n
c-function mpf_cmp_d mpf_cmp_d a r -- n
c-function mpf_cmp_ui mpf_cmp_ui a n -- n
c-function mpf_cmp_si mpf_cmp_si a n -- n
c-function mpf_eq mpf_eq a a n -- n
c-function mpf_reldiff mpf_reldiff a a a -- void
\ c-function mpf_sgn mpf_sgn a -- n

\ 7.7 Input and output

c-function mpf_out_str mpf_out_str a n n a -- n
c-function mpf_inp_str mpf_inp_str a a n -- n

\ 7.8 Miscellaneous

c-function mpf_ceil mpf_ceil a a -- void
c-function mpf_floor mpf_floor a a -- void 
c-function mpf_trunc mpf_trunc a a -- void 
c-function mpf_integer_p mpf_integer_p a -- n
c-function mpf_fits_ulong_p mpf_fits_ulong_p a -- n
c-function mpf_fits_slong_p mpf_fits_slong_p a -- n
c-function mpf_fits_uint_p mpf_fits_uint_p a -- n
c-function mpf_fits_sint_p mpf_fits_sint_p a -- n
c-function mpf_fits_ushort_p mpf_fits_ushort_p a -- n
c-function mpf_fits_sshort_p mpf_fits_sshort_p a -- n
c-function mpf_urandomb mpf_urandomb a a n -- void
c-function mpf_random2 mpf_random2 a n n -- void

\ 8 Low level

\ 9 Random number state

\ 9.1 Initialization

c-function gmp_randinit_default gmp_randinit_default a -- void
c-function gmp_randinit_mt gmp_randinit_mt a -- void
c-function gmp_randinit_lc_2exp gmp_randinit_lc_2exp a a n n -- void
c-function gmp_randinit_lc_2exp_size gmp_randinit_lc_2exp_size a n -- n
c-function gmp_randinit_set gmp_randinit_set a a -- void
c-function gmp_randclear gmp_randclear a -- void

\ 9.2 Seeding

c-function gmp_randseed  gmp_randseed a a -- void
c-function gmp_randseed_ui gmp_randseed_ui a n -- void

\ 9.3 Miscellaneous

c-function gmp_urandomb_ui gmp_urandomb_ui a n -- n
c-function gmp_urandomm_ui gmp_urandomm_ui a n -- n

\ 10 Formatted output

\ 10.1 Format strings

\ 10.2 Functions

\ 11 Formatted input

\ 11.1 Format strings

\ 11.2 Functions

\ libgmp_macros

\c #include <stdio.h>
\c #include <gmp.h>

\c int mpz_sgn_macro (mpz_ptr op) { return mpz_sgn (op); }

\c int mpf_sgn_macro (mpf_ptr op) { return mpf_sgn (op); }

\c int mpq_sgn_macro (mpq_ptr op) { return mpq_sgn (op); }

\c int mpz_cmp_si_macro (mpz_ptr op1, signed long int op2)
\c { return mpz_cmp_si (op1, op2); }

\c int mpz_cmp_ui_macro (mpz_ptr op1, unsigned long int op2)
\c { return mpz_cmp_ui (op1, op2); }

\c int mpz_odd_p_macro (mpz_ptr op) { return mpz_odd_p (op); }

\c int mpz_even_p_macro (mpz_ptr op) { return mpz_odd_p (op); }

\c int mpq_cmp_ui_macro (mpq_ptr op1, unsigned long int num2, unsigned long int den2)
\c { return mpq_cmp_ui (op1, num2, den2); }

\c int mpq_cmp_si_macro (mpq_ptr op1, long int num2, unsigned long int den2)
\c { return mpq_cmp_si (op1, num2, den2); }

\c mpz_srcptr mpq_numref_macro (mpq_ptr op) { return mpq_numref (op); }

\c mpz_srcptr mpq_denref_macro (mpq_ptr op) { return mpq_denref (op); }

\c int sizeof_mpz (void) { return sizeof (mpz_t); }
\c int sizeof_mpq (void) { return sizeof (mpq_t); }
\c int sizeof_mpf (void) { return sizeof (mpf_t); }
\c int bits_per_mp_limb (void) { return mp_bits_per_limb; }
\c int sizeof_gmp_randstate (void) { return sizeof (gmp_randstate_t); }

c-function mpz_cmp_si mpz_cmp_si_macro a n -- n
c-function mpz_cmp_ui mpz_cmp_ui_macro a n -- n
c-function mpz_sgn mpz_sgn_macro a -- n
c-function mpz_odd_p mpz_odd_p_macro a -- n
c-function mpz_even_p mpz_even_p_macro a -- n
c-function mpq_cmp_ui mpq_cmp_ui_macro a n n -- n
c-function mpq_cmp_si mpq_cmp_si_macro a n n -- n
c-function mpq_sgn mpq_sgn_macro a -- n
c-function mpq_numref mpq_numref_macro a -- a
c-function mpq_denref mpq_denref_macro a -- a
c-function mpf_sgn mpf_sgn_macro a -- n

c-value gmp_version gmp_version -- a
c-function /MPZ sizeof_mpz -- n
c-function /MPQ sizeof_mpq -- n
c-function /MPF sizeof_mpf -- n
c-function mp_bits_per_limb bits_per_mp_limb -- n
c-function /GMP-RANDSTATE sizeof_gmp_randstate -- n

end-c-library
