(     Title:  PFE bindings for the GNU Multiple
              Precision Floatint-Point Reliable Library, GNU MPFR 3.0.1
       File:  libmpfr-pfe.fs
  Test file:  gmpr-test.fs
     Author:  David N. Williams
    License:  LGPL
    Version:  0.8.4
    Started:  April 26, 2011 
    Revised:  May 5, 2011

Any part of this file not derived from the GMP library is
)  
\ Copyright  (C) 2011 by David N. Williams
(  
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or at your option any later version.

This library is distributed in the hope that it will be useful 
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Library General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA 02111-1307 USA.
)

s" bindlib.fs" included

LIBRARY libmpfr-pfe
MODULE  mpfr  "mpfr bindings"
WITH-MODULE floating-ext

c{ /* License:  LGPL */
#define _P4_SOURCE 1
#include <stdio.h>
#include <pfe/pfe-base.h>

#include <stdint.h> 	 // either of these...
// #include <inttypes.h> //...works with OS X

#include <gmp.h>
#include <mpfr.h>

#define ulong    unsigned long
}c

N-RET-TYPE	mpfr_prec_t
N-RET-TYPE	mpfr_exp_t
N-RET-TYPE	mpfr_rnd_t
U-RET-TYPE	ulong
N-RET-TYPE	intmax_t
U-RET-TYPE	uintmax_t
U-RET-TYPE	char*
DF-RET-TYPE	float
U-RET-TYPE	size_t

\ libmpfr 3.0.1 functions

\ 5.1 Initialization

c-func mpfr_init	void mpfr_init	(mpfr_ptr);
c-func mpfr_init2	void mpfr_init2	(mpfr_ptr, mpfr_prec_t);
c-func mpfr_clear	void mpfr_clear	(mpfr_ptr);
c-func mpfr_set_default_prec  void mpfr_set_default_prec (mpfr_prec_t);
c-func mpfr_get_default_prec  mpfr_prec_t mpfr_get_default_prec (void);
c-func mpfr_set_prec 	void mpfr_set_prec (mpfr_ptr, mpfr_prec_t);
c-func mpfr_get_prec 	mpfr_prec_t mpfr_get_prec (mpfr_srcptr);

\ 5.2 Assignment
c-func mpfr_set		int mpfr_set	 (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_set_ui	int mpfr_set_ui	 (mpfr_ptr, unsigned long, mpfr_rnd_t);
c-func mpfr_set_si	int mpfr_set_si	 (mpfr_ptr, long, mpfr_rnd_t);
c-func mpfr_set_uj	int mpfr_set_uj  (mpfr_ptr, uintmax_t, mpfr_rnd_t);
c-func mpfr_set_sj	int mpfr_set_sj	 (mpfr_ptr, intmax_t, mpfr_rnd_t);
c-func mpfr_set_flt	int mpfr_set_flt (mpfr_ptr, float, mpfr_rnd_t);
c-func mpfr_set_d	int mpfr_set_d	 (mpfr_ptr, double, mpfr_rnd_t);
\ c-func mpfr_set_ld	int mpfr_set_ld	 (mpfr_ptr, long double, mpfr_rnd_t);
c-func mpfr_set_z	int mpfr_set_z	 (mpfr_ptr, mpz_srcptr, mpfr_rnd_t);
c-func mpfr_set_q	int mpfr_set_q	 (mpfr_ptr, mpq_srcptr, mpfr_rnd_t);
c-func mpfr_set_f	int mpfr_set_f	 (mpfr_ptr, mpf_srcptr, mpfr_rnd_t);
c-func mpfr_set_ui_2exp	int mpfr_set_ui_2exp (mpfr_ptr, unsigned long,
				mpfr_exp_t, mpfr_rnd_t);
c-func mpfr_set_si_2exp	int mpfr_set_si_2exp (mpfr_ptr, long, mpfr_exp_t,
				mpfr_rnd_t);
c-func mpfr_set_uj_2exp	int mpfr_set_uj_2exp (mpfr_ptr, uintmax_t,
				intmax_t, mpfr_rnd_t);
c-func mpfr_set_sj_2exp	int mpfr_set_sj_2exp (mpfr_ptr, intmax_t,
				intmax_t, mpfr_rnd_t);
c-func mpfr_set_z_2exp	int mpfr_set_z_2exp (mpfr_ptr, mpz_srcptr,
				mpfr_exp_t, mpfr_rnd_t);
c-func mpfr_set_str	int mpfr_set_str (mpfr_ptr, __gmp_const char *,
				int, mpfr_rnd_t);
c-func mpfr_strtofr	int mpfr_strtofr (mpfr_ptr, __gmp_const char *,
				char **, int, mpfr_rnd_t);

c-func mpfr_set_nan	void mpfr_set_nan (mpfr_ptr);
c-func mpfr_set_inf	void mpfr_set_inf (mpfr_ptr, int);
c-func mpfr_set_zero	void mpfr_set_zero (mpfr_ptr, int);

c-func mpfr_swap	void mpfr_swap (mpfr_ptr, mpfr_ptr);

\ 5.3 Combined initialization and assignment

c-func mpfr_init_set	int mpfr_init_set (mpfr_ptr, mpfr_ptr, mpfr_rnd_t);
c-func mpfr_init_set_ui	int mpfr_init_set_ui (mpfr_ptr, unsigned long int,
				mpfr_rnd_t);
c-func mpfr_init_set_si	int mpfr_init_set_si (mpfr_ptr, long int, mpfr_rnd_t);
c-func mpfr_init_set_d	int mpfr_init_set_d (mpfr_ptr, double, mpfr_rnd_t);
\ c-func mpfr_init_set_ld int mpfr_init_set_ld (mpfr_ptr, double, mpfr_rnd_t);
c-func mpfr_init_set_z	int mpfr_init_set_z (mpfr_ptr, mpz_ptr, mpfr_rnd_t);
c-func mpfr_init_set_q	int mpfr_init_set_q (mpfr_ptr, mpq_ptr, mpfr_rnd_t);
c-func mpfr_init_set_f	int mpfr_init_set_f (mpfr_ptr, mpf_ptr, mpfr_rnd_t);

c-func mpfr_init_set_str  int mpfr_init_set_str (mpfr_ptr,
				__gmp_const char *, int, mpfr_rnd_t);

\ 5.4 Conversion

c-func mpfr_get_flt	float  mpfr_get_flt (mpfr_ptr, mpfr_rnd_t);
c-func mpfr_get_d	double mpfr_get_d (mpfr_ptr, mpfr_rnd_t);
\ c-func mpfr_get_ld	ldouble mpfr_get_ld (mpfr_ptr, mpfr_rnd_t);

c-func mpfr_get_si	long      mpfr_get_si (mpfr_ptr, mpfr_rnd_t);
c-func mpfr_get_ui	ulong     mpfr_get_ui (mpfr_ptr, mpfr_rnd_t);
c-func mpfr_get_sj	intmax_t  mpfr_get_sj (mpfr_ptr, mpfr_rnd_t);
c-func mpfr_get_uj	uintmax_t mpfr_get_uj (mpfr_ptr, mpfr_rnd_t);

c-func mpfr_get_d_2exp	double mpfr_get_d_2exp (long *, mpfr_ptr, mpfr_rnd_t);
\ c-func mpfr_get_ld_2exp ldouble mpfr_get_ld_2exp (long *, mpfr_ptr, mpfr_rnd_t);
c-func mpfr_get_z_2exp	mpfr_exp_t mpfr_get_z_2exp (mpz_ptr, mpfr_ptr);

c-func mpfr_get_z	int   mpfr_get_z (mpz_ptr, mpfr_ptr, mpfr_rnd_t);
c-func mpfr_get_f	int   mpfr_get_f (mpf_ptr, mpfr_ptr, mpfr_rnd_t);
c-func mpfr_get_str	char* mpfr_get_str (char *, mpfr_exp_t *,
				int, size_t, mpfr_ptr, mpfr_rnd_t);
c-func mpfr_free_str	void mpfr_free_str (char *);

c-func mpfr_fits_ulong_p   int mpfr_fits_ulong_p (mpfr_ptr, mpfr_rnd_t);
c-func mpfr_fits_slong_p   int mpfr_fits_slong_p (mpfr_ptr, mpfr_rnd_t);
c-func mpfr_fits_uint_p    int mpfr_fits_uint_p	 (mpfr_ptr, mpfr_rnd_t);
c-func mpfr_fits_sint_p	   int mpfr_fits_sint_p (mpfr_ptr, mpfr_rnd_t);
c-func mpfr_fits_ushort_p  int mpfr_fits_ushort_p (mpfr_ptr, mpfr_rnd_t);
c-func mpfr_fits_sshort_p  int mpfr_fits_sshort_p (mpfr_ptr, mpfr_rnd_t);
c-func mpfr_fits_uintmax_p int mpfr_fits_uintmax_p (mpfr_ptr, mpfr_rnd_t);
c-func mpfr_fits_intmax_p  int mpfr_fits_intmax_p (mpfr_ptr, mpfr_rnd_t);

\ 5.5 Basic Arithmetic

c-func mpfr_add		int mpfr_add (mpfr_ptr, mpfr_srcptr,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_add_ui	int mpfr_add_ui	(mpfr_ptr, mpfr_srcptr,
				unsigned long, mpfr_rnd_t);
c-func mpfr_add_si	int mpfr_add_si	(mpfr_ptr, mpfr_srcptr,
				long int, mpfr_rnd_t);
c-func mpfr_add_d	int mpfr_add_d (mpfr_ptr, mpfr_srcptr,
				double, mpfr_rnd_t);
c-func mpfr_add_z	int mpfr_add_z	(mpfr_ptr, mpfr_srcptr,
				mpz_srcptr, mpfr_rnd_t);
c-func mpfr_add_q	int mpfr_add_q	(mpfr_ptr, mpfr_srcptr,
				mpq_srcptr, mpfr_rnd_t);

c-func mpfr_sub		int mpfr_sub (mpfr_ptr, mpfr_srcptr,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_ui_sub	int mpfr_ui_sub	(mpfr_ptr, unsigned long,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_sub_ui	int mpfr_sub_ui	(mpfr_ptr, mpfr_srcptr,
				unsigned long, mpfr_rnd_t);
c-func mpfr_si_sub	int mpfr_si_sub (mpfr_ptr, long int,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_sub_si	int mpfr_sub_si (mpfr_ptr, mpfr_srcptr,
                                              long int, mpfr_rnd_t);
c-func mpfr_d_sub	int mpfr_d_sub	(mpfr_ptr, double,
                                              mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_sub_d	int mpfr_sub_d	(mpfr_ptr, mpfr_srcptr,
				double, mpfr_rnd_t);
c-func mpfr_sub_z	int mpfr_sub_z	(mpfr_ptr, mpfr_srcptr,
				mpz_srcptr, mpfr_rnd_t);
c-func mpfr_sub_q	int mpfr_sub_q	(mpfr_ptr, mpfr_srcptr,
				mpq_srcptr, mpfr_rnd_t);

c-func mpfr_mul		int mpfr_mul (mpfr_ptr, mpfr_srcptr,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_mul_ui	int mpfr_mul_ui	(mpfr_ptr, mpfr_srcptr,
				unsigned long, mpfr_rnd_t);
c-func mpfr_mul_si	int mpfr_mul_si	(mpfr_ptr, mpfr_srcptr,
				long int, mpfr_rnd_t);
c-func mpfr_mul_d	int mpfr_mul_d	(mpfr_ptr, mpfr_srcptr,
				double, mpfr_rnd_t);
c-func mpfr_mul_z	int mpfr_mul_z	(mpfr_ptr, mpfr_srcptr,
				mpz_srcptr, mpfr_rnd_t);
c-func mpfr_mul_q	int mpfr_mul_q	(mpfr_ptr, mpfr_srcptr,
				mpq_srcptr, mpfr_rnd_t);

c-func mpfr_sqr		int mpfr_sqr (mpfr_ptr, mpfr_srcptr,mpfr_rnd_t);

c-func mpfr_div		int mpfr_div (mpfr_ptr, mpfr_srcptr,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_ui_div	int mpfr_ui_div	(mpfr_ptr, unsigned long,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_div_ui	int mpfr_div_ui	(mpfr_ptr, mpfr_srcptr,
 				unsigned long, mpfr_rnd_t);
c-func mpfr_si_div	int mpfr_si_div	(mpfr_ptr, long int,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_div_si	int mpfr_div_si	(mpfr_ptr, mpfr_srcptr,
				long int, mpfr_rnd_t);
c-func mpfr_d_div 	int mpfr_d_div	(mpfr_ptr, double,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_div_d	int mpfr_div_d	(mpfr_ptr, mpfr_srcptr,
				double, mpfr_rnd_t);
c-func mpfr_div_z	int mpfr_div_z	(mpfr_ptr, mpfr_srcptr,
				mpz_srcptr, mpfr_rnd_t);
c-func mpfr_div_q	int mpfr_div_q	(mpfr_ptr, mpfr_srcptr,
				mpq_srcptr, mpfr_rnd_t);

c-func mpfr_sqrt	int mpfr_sqrt (mpfr_ptr, mpfr_srcptr,
				mpfr_rnd_t);
c-func mpfr_sqrt_ui	int mpfr_sqrt_ui (mpfr_ptr, unsigned long,
				mpfr_rnd_t);
c-func mpfr_rec_sqrt	int mpfr_rec_sqrt (mpfr_ptr, mpfr_srcptr,
				mpfr_rnd_t);
c-func mpfr_cbrt	int mpfr_cbrt (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_root	int mpfr_root (mpfr_ptr, mpfr_srcptr,
				unsigned long,mpfr_rnd_t);

c-func mpfr_pow		int mpfr_pow (mpfr_ptr, mpfr_srcptr,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_pow_ui	int mpfr_pow_ui	(mpfr_ptr, mpfr_srcptr,
				unsigned long int, mpfr_rnd_t);
c-func mpfr_pow_si	int mpfr_pow_si (mpfr_ptr, mpfr_srcptr,
				long int, mpfr_rnd_t);
c-func mpfr_pow_z	int mpfr_pow_z (mpfr_ptr, mpfr_srcptr,
				mpz_srcptr, mpfr_rnd_t);
c-func mpfr_ui_pow_ui	int mpfr_ui_pow_ui (mpfr_ptr, unsigned long int,
				unsigned long int, mpfr_rnd_t);
c-func mpfr_ui_pow	int mpfr_ui_pow	(mpfr_ptr, unsigned long int,
				mpfr_srcptr, mpfr_rnd_t);

c-func mpfr_neg		int mpfr_neg (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_abs		int mpfr_abs (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);

c-func mpfr_dim		int mpfr_dim (mpfr_ptr, mpfr_srcptr, mpfr_srcptr,
				mpfr_rnd_t);

c-func mpfr_mul_2ui	int mpfr_mul_2ui (mpfr_ptr, mpfr_srcptr,
				unsigned long, mpfr_rnd_t);
c-func mpfr_mul_2si	int mpfr_mul_2si (mpfr_ptr, mpfr_srcptr,
				long, mpfr_rnd_t);
c-func mpfr_div_2ui	int mpfr_div_2ui (mpfr_ptr, mpfr_srcptr,
				unsigned long, mpfr_rnd_t);
c-func mpfr_div_2si	int mpfr_div_2si (mpfr_ptr, mpfr_srcptr,
				long, mpfr_rnd_t);

\ 5.6 Comparison

c-func mpfr_cmp		int mpfr_cmp (mpfr_srcptr, mpfr_srcptr);
c-func mpfr_cmp_ui	int mpfr_cmp_ui	(mpfr_srcptr, unsigned long);
c-func mpfr_cmp_si	int mpfr_cmp_si	(mpfr_srcptr, long);
c-func mpfr_cmp_d	int mpfr_cmp_d	(mpfr_srcptr, double);
\ c-func mpfr_cmp_ld	int mpfr_cmp_ld	(mpfr_srcptr, long double);
c-func mpfr_eq		int mpfr_eq (mpfr_srcptr, mpfr_srcptr,
				unsigned long);
c-func mpfr_cmp_z	int mpfr_cmp_z (mpfr_srcptr, mpz_srcptr);
c-func mpfr_cmp_q	int mpfr_cmp_q (mpfr_srcptr, mpq_srcptr);
c-func mpfr_cmp_f	int mpfr_cmp_f (mpfr_srcptr, mpf_srcptr);

c-func mpfr_cmp_ui_2exp	int mpfr_cmp_ui_2exp (mpfr_srcptr, unsigned long,
				mpfr_exp_t);
c-func mpfr_cmp_si_2exp	int mpfr_cmp_si_2exp (mpfr_srcptr, long,
				mpfr_exp_t);

c-func mpfr_cmpabs	int mpfr_cmpabs	(mpfr_srcptr, mpfr_srcptr);

c-func mpfr_nan_p	int mpfr_nan_p (mpfr_srcptr);
c-func mpfr_inf_p	int mpfr_inf_p (mpfr_srcptr);
c-func mpfr_number_p	int mpfr_number_p (mpfr_srcptr);
c-func mpfr_zero_p	int mpfr_zero_p	(mpfr_srcptr);
c-func mpfr_regular_p	int mpfr_regular_p (mpfr_srcptr) ;
c-func mpfr_sgn		int mpfr_sgn (mpfr_srcptr);

c-func mpfr_greater_p	   int mpfr_greater_p (mpfr_srcptr, mpfr_srcptr);
c-func mpfr_greaterequal_p int mpfr_greaterequal_p (mpfr_srcptr, mpfr_srcptr) ;
c-func mpfr_less_p	   int mpfr_less_p (mpfr_srcptr, mpfr_srcptr);
c-func mpfr_lessequal_p	   int mpfr_lessequal_p	(mpfr_srcptr, mpfr_srcptr);
c-func mpfr_equal_p	   int mpfr_equal_p (mpfr_srcptr, mpfr_srcptr);
c-func mpfr_lessgreater_p  int mpfr_lessgreater_p (mpfr_srcptr, mpfr_srcptr);
c-func mpfr_unordered_p	   int mpfr_unordered_p	(mpfr_srcptr, mpfr_srcptr);

\ 5.7 Special Functions

c-func mpfr_log		int mpfr_log (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_log2	int mpfr_log2 (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_log10	int mpfr_log10 (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_exp		int mpfr_exp (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_exp2	int mpfr_exp2 (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_exp10	int mpfr_exp10 (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_cos		int mpfr_cos (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_sin		int mpfr_sin (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_tan		int mpfr_tan (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_sin_cos	int mpfr_sin_cos (mpfr_ptr, mpfr_ptr,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_sec		int mpfr_sec (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_csc		int mpfr_csc (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_cot		int mpfr_cot (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_acos	int mpfr_acos (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_asin	int mpfr_asin (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_atan	int mpfr_atan (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_atan2	int mpfr_atan2 (mpfr_ptr,mpfr_srcptr,mpfr_srcptr,
				mpfr_rnd_t);
c-func mpfr_cosh	int mpfr_cosh (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_sinh	int mpfr_sinh (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_tanh	int mpfr_tanh (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_sinh_cosh	int mpfr_sinh_cosh (mpfr_ptr, mpfr_ptr,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_sech	int mpfr_sech (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_csch	int mpfr_csch (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_coth	int mpfr_coth (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_acosh	int mpfr_acosh (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_asinh	int mpfr_asinh (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_atanh	int mpfr_atanh (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_fac_ui	int mpfr_fac_ui (mpfr_ptr, unsigned long int,
				mpfr_rnd_t);
c-func mpfr_log1p	int mpfr_log1p (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_expm1	int mpfr_expm1 (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_eint	int mpfr_eint (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_li2		int mpfr_li2 (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_gamma	int mpfr_gamma (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_lngamma	int mpfr_lngamma (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_lgamma	int mpfr_lgamma	(mpfr_ptr, int*, mpfr_srcptr,
				mpfr_rnd_t);
c-func mpfr_digamma	int mpfr_digamma (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_zeta	int mpfr_zeta (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_zeta_ui	int mpfr_zeta_ui (mpfr_ptr, unsigned long, mpfr_rnd_t);
c-func mpfr_erf		int mpfr_erf (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_erfc	int mpfr_erfc (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_j0		int mpfr_j0 (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_j1		int mpfr_j1 (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_jn		int mpfr_jn (mpfr_ptr, long, mpfr_srcptr,
 				mpfr_rnd_t);
c-func mpfr_y0		int mpfr_y0 (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_y1		int mpfr_y1 (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_yn		int mpfr_yn (mpfr_ptr, long, mpfr_srcptr,
				mpfr_rnd_t);
c-func mpfr_fma		int mpfr_fma (mpfr_ptr, mpfr_srcptr, mpfr_srcptr,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_fms		int mpfr_fms (mpfr_ptr, mpfr_srcptr, mpfr_srcptr,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_agm		int mpfr_agm (mpfr_ptr, mpfr_srcptr, mpfr_srcptr,
				mpfr_rnd_t);
c-func mpfr_hypot	int mpfr_hypot (mpfr_ptr, mpfr_srcptr,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_ai		int mpfr_ai (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);

c-func mpfr_const_log2	  int mpfr_const_log2 (mpfr_ptr, mpfr_rnd_t);
c-func mpfr_const_pi	  int mpfr_const_pi (mpfr_ptr, mpfr_rnd_t);
c-func mpfr_const_euler	  int mpfr_const_euler (mpfr_ptr, mpfr_rnd_t);
c-func mpfr_const_catalan int mpfr_const_catalan (mpfr_ptr, mpfr_rnd_t);

c-func mpfr_free_cache	void mpfr_free_cache (void) ;

c-func mpfr_sum		int mpfr_sum (mpfr_ptr, mpfr_ptr *__gmp_const,
				unsigned long, mpfr_rnd_t);

\ 5.8 Input and output

c-func mpfr_out_str	size_t mpfr_out_str (FILE*, int, size_t,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_inp_str	size_t mpfr_inp_str (mpfr_ptr, FILE*, int,
				mpfr_rnd_t);

\ 5.9 Formatted Output

\ 5.10 Integer and Remainder Related Functions

c-func mpfr_rint	int  mpfr_rint (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_ceil	int mpfr_ceil (mpfr_ptr, mpfr_srcptr);
c-func mpfr_floor	int mpfr_floor (mpfr_ptr, mpfr_srcptr);
c-func mpfr_round	int mpfr_round (mpfr_ptr, mpfr_srcptr);
c-func mpfr_trunc	int mpfr_trunc (mpfr_ptr, mpfr_srcptr);

c-func mpfr_rint_ceil	int mpfr_rint_ceil (mpfr_ptr, mpfr_srcptr,
				mpfr_rnd_t);
c-func mpfr_rint_floor	int mpfr_rint_floor (mpfr_ptr, mpfr_srcptr,
				mpfr_rnd_t);
c-func mpfr_rint_round	int mpfr_rint_round (mpfr_ptr, mpfr_srcptr,
				mpfr_rnd_t);
c-func mpfr_rint_trunc	int mpfr_rint_trunc (mpfr_ptr, mpfr_srcptr,
				mpfr_rnd_t);

c-func mpfr_frac	int mpfr_frac (mpfr_ptr, mpfr_srcptr, mpfr_rnd_t);

c-func mpfr_modf	int mpfr_modf (mpfr_ptr, mpfr_ptr, mpfr_srcptr,
				mpfr_rnd_t);

c-func mpfr_fmod	int mpfr_fmod (mpfr_ptr, mpfr_srcptr,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_remainder	int mpfr_remainder (mpfr_ptr, mpfr_srcptr,
				mpfr_srcptr, mpfr_rnd_t);
c-func mpfr_remquo	int mpfr_remquo	(mpfr_ptr, long*, mpfr_srcptr,
				mpfr_srcptr, mpfr_rnd_t);

c-func mpfr_integer_p	int mpfr_integer_p (mpfr_srcptr);

\ 5.11 Rounding Related Functions

c-func mpfr_set_default_rounding_mode
	   void mpfr_set_default_rounding_mode (mpfr_rnd_t);
c-func mpfr_get_default_rounding_mode
	   mpfr_rnd_t mpfr_get_default_rounding_mode (void);

c-func mpfr_prec_round	int mpfr_prec_round (mpfr_ptr, mpfr_prec_t,
				mpfr_rnd_t);
c-func mpfr_can_round	int mpfr_can_round (mpfr_srcptr, mpfr_exp_t,
				mpfr_rnd_t, mpfr_rnd_t, mpfr_prec_t);

c-func mpfr_min_prec	mpfr_prec_t mpfr_min_prec (mpfr_srcptr);

c-func mpfr_print_rnd_mode char* mpfr_print_rnd_mode (mpfr_rnd_t);

\ 5.12 Miscellaneous Functions

c-func mpfr_nexttoward	void mpfr_nexttoward (mpfr_ptr, mpfr_srcptr);
c-func mpfr_nextabove	void mpfr_nextabove (mpfr_ptr);
c-func mpfr_nextbelow	void mpfr_nextbelow (mpfr_ptr);

c-func mpfr_min		int mpfr_min (mpfr_ptr, mpfr_srcptr, mpfr_srcptr,
				mpfr_rnd_t);
c-func mpfr_max		int mpfr_max (mpfr_ptr, mpfr_srcptr, mpfr_srcptr,
				mpfr_rnd_t);

\ c-func mpfr_urandomb	int mpfr_urandomb (mpfr_ptr, gmp_randstate_t);
\ c-func mpfr_urandom	int mpfr_urandom (mpfr_ptr, gmp_randstate_t, mpfr_rnd_t);
c-func mpfr_urandomb	int mpfr_urandomb (mpfr_ptr, void*);
c-func mpfr_urandom	int mpfr_urandom (mpfr_ptr, void*, mpfr_rnd_t);

c-func mpfr_get_exp	mpfr_exp_t mpfr_get_exp	(mpfr_srcptr);
c-func mpfr_set_exp	int	   mpfr_set_exp (mpfr_ptr, mpfr_exp_t);

c-func mpfr_signbit	int mpfr_signbit (mpfr_srcptr);
c-func mpfr_setsign	int mpfr_setsign (mpfr_ptr, mpfr_srcptr,
				int, mpfr_rnd_t);
c-func mpfr_copysign	int mpfr_copysign (mpfr_ptr, mpfr_srcptr,
				mpfr_srcptr, mpfr_rnd_t);

c-func mpfr_get_version	char* mpfr_get_version (void);

\ 5.13 Exception Related Functions

c-func mpfr_get_emin	mpfr_exp_t mpfr_get_emin (void);
c-func mpfr_get_emax	mpfr_exp_t mpfr_get_emax (void);
c-func mpfr_set_emin 	int mpfr_set_emin (mpfr_exp_t);
c-func mpfr_set_emax	int mpfr_set_emax (mpfr_exp_t);

c-func mpfr_get_emin_min  mpfr_exp_t mpfr_get_emin_min (void);
c-func mpfr_get_emin_max  mpfr_exp_t mpfr_get_emin_max (void);
c-func mpfr_get_emax_min  mpfr_exp_t mpfr_get_emax_min (void);
c-func mpfr_get_emax_max  mpfr_exp_t mpfr_get_emax_max (void);

c-func mpfr_check_range	 int mpfr_check_range (mpfr_ptr, int, mpfr_rnd_t);
c-func mpfr_subnormalize int mpfr_subnormalize (mpfr_ptr, int, mpfr_rnd_t);

c-func mpfr_clear_underflow  void mpfr_clear_underflow (void);
c-func mpfr_clear_overflow   void mpfr_clear_overflow (void);
c-func mpfr_clear_nanflag    void mpfr_clear_nanflag (void);
c-func mpfr_clear_inexflag   void mpfr_clear_inexflag (void);
c-func mpfr_clear_erangeflag void mpfr_clear_erangeflag (void);

c-func mpfr_set_underflow  void mpfr_set_underflow (void);
c-func mpfr_set_overflow   void mpfr_set_overflow (void);
c-func mpfr_set_nanflag    void  mpfr_set_nanflag (void);
c-func mpfr_set_inexflag   void  mpfr_set_inexflag (void);
c-func mpfr_set_erangeflag void mpfr_set_erangeflag (void);

c-func mpfr_clear_flags void mpfr_clear_flags (void);

c-func mpfr_underflow_p  int mpfr_underflow_p (void);
c-func mpfr_overflow_p   int mpfr_overflow_p (void);
c-func mpfr_nanflag_p    int mpfr_nanflag_p (void);
c-func mpfr_inexflag_p   int mpfr_inexflag_p (void);
c-func mpfr_erangeflag_p int mpfr_erangeflag_p (void);

\ 5.14 Compatibility With MPF

c-func mpfr_reldiff	void mpfr_reldiff (mpfr_ptr, mpfr_srcptr,
				mpfr_srcptr, mpfr_rnd_t);
\ 5.15 Custom Interface

\ Constants

c-val /MPFR		sizeof (mpfr_t) ;
c-val MPFR_PREC_MIN     MPFR_PREC_MIN ;
c-val MPFR_PREC_MAX     MPFR_PREC_MAX ;
c-val MPFR_EMAX_DEFAULT MPFR_EMAX_DEFAULT ;
c-val MPFR_EMIN_DEFAULT MPFR_EMIN_DEFAULT ;
c-val MPFR_RNDN 	MPFR_RNDN ;
c-val MPFR_RNDZ		MPFR_RNDZ ;
c-val MPFR_RNDU		MPFR_RNDU ;
c-val MPFR_RNDD		MPFR_RNDD ;
c-val MPFR_RNDA		MPFR_RNDA ;
c-val MPFR_RNDF		MPFR_RNDF ;
c-val MPFR_RNDNA	MPFR_RNDNA ;

END-LIBRARY
