(   Title:  Enhanced error display for bntester
     File:  mftester-errors.fs
 Log file:  gmpfr.log
   Author:  David N. Williams
  License:  Public Domain
  Version:  1.5.0
  Started:  March 2, 2011
  Revised:  March 9, 2011
)

VARIABLE MFT-#ERRORS    0 MFT-#ERRORS !
: MFT-ERROR1  ( c-addr u -- )
\ Display an error message followed by the line that had the
\ error.
  red-text 1 MFT-#ERRORS +! MFT-ERROR-DEFAULT normal-text ;
\ ' MFT-ERROR1 MFT-ERROR-XT !

\ display results and goals
: mft-a.  ( 'array c-addr u -- )
  blue-text type
  ( 'array) dup >r @ dup
  IF   1- r> cell+ swap cells over +  \ display deepest first
       DO i mf@ mf. space -1 cells +LOOP
  ELSE r> 2drop ." none" THEN cr normal-text ;

: MFT-ERROR2  ( c-addr u -- )
  MFT-ERROR1
  mft-results s"  mfresults: " mft-a.
  mft-goals   s"    mfgoals: " mft-a. ;
\ ' MFT-ERROR2 MFT-ERROR-XT !

\ fancy results and goals display
: mft-fancy-a.  ( 'array c-addr u -- )
  blue-text type
  ( 'array) dup @ swap cell+ swap ?dup
  IF   ( n) 1- 0 swap  \ display deepest first
       DO ( 'elem) i cells over + mf@
          i mft-error-index @ =
          IF red-text mf. blue-text ELSE mf. THEN space
       -1 +LOOP
  ELSE ." none" THEN drop cr normal-text ;

: MFT-ERROR3  ( c-addr u -- )
  MFT-ERROR1
  mft-results s"  mfresults: " mft-fancy-a.
  mft-goals   s"    mfgoals: " mft-fancy-a. ;
' MFT-ERROR3 MFT-ERROR-XT !

: ?.mft-errors  ( -- )
  VERBOSE @ IF
  blue-text ." MFT-ERRORS: " normal-text MFT-#ERRORS @ . THEN ;
