(   Title:  Enhanced error display for qtester
     File:  qtester-errors.fs
 Log file:  gmpfr.log
   Author:  David N. Williams
  License:  Public Domain
  Version:  1.5.0
  Started:  March 10, 2011
  Revised:  March 10, 2011
)

VARIABLE QT-#ERRORS    0 QT-#ERRORS !
: QT-ERROR1  ( c-addr u -- )
\ Display an error message followed by the line that had the
\ error.
  red-text 1 QT-#ERRORS +! QT-ERROR-DEFAULT normal-text ;
\ ' QT-ERROR1 QT-ERROR-XT !

\ display results and goals
: qt-a.  ( 'array c-addr u -- )
  blue-text type
  ( 'array) dup >r @ dup
  IF   1- r> cell+ swap cells over +  \ display deepest first
       DO i q@ q. space -1 cells +LOOP
  ELSE r> 2drop ." none" THEN cr normal-text ;

: QT-ERROR2  ( c-addr u -- )
  QT-ERROR1
  qt-results s"  qresults: " qt-a.
  qt-goals   s"    qgoals: " qt-a. ;
\ ' QT-ERROR2 QT-ERROR-XT !

\ fancy results and goals display
: qt-fancy-a.  ( 'array c-addr u -- )
  blue-text type
  ( 'array) dup @ swap cell+ swap ?dup
  IF   ( n) 1- 0 swap  \ display deepest first
       DO ( 'elem) i cells over + q@
          i qt-error-index @ =
          IF red-text q. blue-text ELSE q. THEN space
       -1 +LOOP
  ELSE ." none" THEN drop cr normal-text ;

: QT-ERROR3  ( c-addr u -- )
  QT-ERROR1
  qt-results s"  qresults: " qt-fancy-a.
  qt-goals   s"    qgoals: " qt-fancy-a. ;
' QT-ERROR3 QT-ERROR-XT !

: ?.qt-errors  ( -- )
  VERBOSE @ IF
  blue-text ." QT-ERRORS: " normal-text QT-#ERRORS @ . THEN ;
