(   Title:  Enhanced error display for bntester
     File:  rftester-errors.fs
   Author:  David N. Williams
 Log file:  gmpfr.log
  License:  Public Domain
  Version:  1.5.0
  Started:  March 26, 2011
  Revised:  April 18, 2011
)

VARIABLE RFT-#ERRORS    0 RFT-#ERRORS !
: RFT-ERROR1  ( c-addr u -- )
\ Display an error message followed by the line that had the
\ error.
  red-text 1 RFT-#ERRORS +! RFT-ERROR-DEFAULT normal-text ;
\ ' RFT-ERROR1 RFT-ERROR-XT !

\ display results and goals
: rft-a.  ( 'array c-addr u -- )
  blue-text type
  ( 'array) dup >r @ dup
  IF   1- r> cell+ swap cells over +  \ display deepest first
       DO i rf@ rf. space -1 cells +LOOP
  ELSE r> 2drop ." none" THEN cr normal-text ;

: RFT-ERROR2  ( c-addr u -- )
  RFT-ERROR1
  rft-results s"  rfresults: " rft-a.
  rft-goals   s"    rfgoals: " rft-a. ;
\ ' RFT-ERROR2 RFT-ERROR-XT !

\ fancy results and goals display
: rft-fancy-a.  ( 'array c-addr u -- )
  blue-text type
  ( 'array) dup @ swap cell+ swap ?dup
  IF   ( n) 1- 0 swap  \ display deepest first
       DO ( 'elem) i cells over + rf@
          i rft-error-index @ =
          IF red-text rf. blue-text ELSE rf. THEN space
       -1 +LOOP
  ELSE ." none" THEN drop cr normal-text ;

: RFT-ERROR3  ( c-addr u -- )
  RFT-ERROR1
  rft-results s"  rfresults: " rft-fancy-a.
  rft-goals   s"    rfgoals: " rft-fancy-a. ;
' RFT-ERROR3 RFT-ERROR-XT !

: ?.rft-errors  ( -- )
  VERBOSE @ IF
  blue-text ." RFT-ERRORS: " normal-text RFT-#ERRORS @ . THEN ;
